# ]po[ Timesheet Workflow
This package is part of ]project-open[, an open-source enterprise project management system.

For more information about ]project-open[ please see:
* [Documentation Wiki](https://www.project-open.com/en/)
* [V5.0 Download](https://sourceforge.net/projects/project-open/files/project-open/V5.0/)
* [Installation Instructions](https://www.project-open.com/en/list-installers)

About ]po[ Timesheet Workflow:

<p>Installing this optional package adds functionality to ]po[ that allows supervisors to approve the hours logged by their reports using a simple but structured workflow. <p>

# Online Reference Documentation

## Procedure Files

<table cellpadding="0" cellspacing="0"><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/procs-file-view?version_id=824366&amp;path=packages/intranet-timesheet2-workflow/tcl/intranet-timesheet2-workflow-procs.tcl">tcl/intranet-timesheet2-workflow-procs.tcl</a></b></td><td></td><td>Definitions for the intranet timesheet workflow </td></tr></table>

## Procedures

<table cellpadding="0" cellspacing="0"><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=824366&amp;proc=eval_wf_start_date">eval_wf_start_date</a></b></td><td></td><td>Helper routine to evaluate start for each week in TS calendar view for Weekly TS confirmation </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=824366&amp;proc=im_timesheet2_workflow_unsubmitted_hours_user_notification_sweeper">im_timesheet2_workflow_unsubmitted_hours_user_notification_sweeper</a></b></td><td></td><td>Sweeper process (executed by &quot;cron&quot; type of function, so it doesn&#39;t have access to ad_form and other functions) that checks if users have logged hours that are not yet submitted to a timesheet workflow. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=824366&amp;proc=im_timesheet_conf_new_page_wf_perm_delete_button">im_timesheet_conf_new_page_wf_perm_delete_button</a></b></td><td></td><td>Should we show the &quot;Delete&quot; button in the TimesheetConfNewPage? The button is visible only for the Owner of the timesheet and the Admin, but nobody else during the course of the WF. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=824366&amp;proc=im_timesheet_conf_new_page_wf_perm_edit_button">im_timesheet_conf_new_page_wf_perm_edit_button</a></b></td><td></td><td>Should we show the &quot;Edit&quot; button in the TimesheetConfNewPage? </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=824366&amp;proc=im_timesheet_conf_new_page_wf_perm_table">im_timesheet_conf_new_page_wf_perm_table</a></b></td><td></td><td>Returns a hash array representing (role x status) -&gt; (v r d w a), controlling the read and write permissions on the Timesheet Conf Object&#39;s new page, depending on the users&#39;s role and the WF status. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=824366&amp;proc=im_timesheet_conf_obj_status_active">im_timesheet_conf_obj_status_active</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=824366&amp;proc=im_timesheet_conf_obj_status_deleted">im_timesheet_conf_obj_status_deleted</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=824366&amp;proc=im_timesheet_conf_obj_status_rejected">im_timesheet_conf_obj_status_rejected</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=824366&amp;proc=im_timesheet_conf_obj_status_requested">im_timesheet_conf_obj_status_requested</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=824366&amp;proc=im_timesheet_conf_obj_type_default">im_timesheet_conf_obj_type_default</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=824366&amp;proc=im_timesheet_conf_object_delete">im_timesheet_conf_object_delete</a></b></td><td></td><td>Delete a confirmation object for the specified (main-) project that covers the specified day. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=824366&amp;proc=im_timesheet_conf_object_new">im_timesheet_conf_object_new</a></b></td><td></td><td>Create a new confirmation object </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=824366&amp;proc=im_timesheet_conf_object_notify_supervisor">im_timesheet_conf_object_notify_supervisor</a></b></td><td></td><td>Notifiy supervisor if hours are touched in the past. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=824366&amp;proc=im_timesheet_workflow_spawn_update_workflow">im_timesheet_workflow_spawn_update_workflow</a></b></td><td></td><td>Check if there is already a WF running for that project/user/date and either reset this WF or create a new one if there wasn&#39;t one before. </td></tr></table>

## SQL Files

<table cellpadding="0" cellspacing="0"><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-timesheet2-workflow&amp;url=postgresql/intranet-timesheet2-workflow-create.sql&amp;version_id=824366">sql/postgresql/intranet-timesheet2-workflow-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-timesheet2-workflow&amp;url=postgresql/intranet-timesheet2-workflow-drop.sql&amp;version_id=824366">sql/postgresql/intranet-timesheet2-workflow-drop.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-timesheet2-workflow&amp;url=postgresql/intranet-timesheet2-workflow-workflow.sql&amp;version_id=824366">sql/postgresql/intranet-timesheet2-workflow-workflow.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-timesheet2-workflow&amp;url=postgresql/workflow-timesheet_approval_wf-create.sql&amp;version_id=824366">sql/postgresql/workflow-timesheet_approval_wf-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-timesheet2-workflow&amp;url=postgresql/workflow-vacation_approval_wf-create.sql&amp;version_id=824366">sql/postgresql/workflow-vacation_approval_wf-create.sql</a></b></td><td></td><td></td></tr></table>

## Content Pages

<table cellpadding="0" cellspacing="0"><tr valign="top"><td><b>www/</b></td></tr><tr valign="top"><td><b>absences/</b></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=824366&amp;path=packages/intranet-timesheet2-workflow/www/absences/absence-panel.adp">absence-panel.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=824366&amp;path=packages/intranet-timesheet2-workflow/www/absences/absence-panel.tcl">absence-panel.tcl</a></b></td><td></td></tr><tr valign="top"><td><b>admin/</b></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=824366&amp;path=packages/intranet-timesheet2-workflow/www/admin/clean-up-conf-objects.tcl">clean-up-conf-objects.tcl</a></b></td><td>Admin page for intranet-timesheet2-workflow</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=824366&amp;path=packages/intranet-timesheet2-workflow/www/admin/index.adp">index.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=824366&amp;path=packages/intranet-timesheet2-workflow/www/admin/index.tcl">index.tcl</a></b></td><td>Admin page for intranet-timesheet2-workflow</td></tr><tr valign="top"><td><b>conf-objects/</b></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=824366&amp;path=packages/intranet-timesheet2-workflow/www/conf-objects/conf-obj-panel.adp">conf-obj-panel.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=824366&amp;path=packages/intranet-timesheet2-workflow/www/conf-objects/conf-obj-panel.tcl">conf-obj-panel.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=824366&amp;path=packages/intranet-timesheet2-workflow/www/conf-objects/delete.tcl">delete.tcl</a></b></td><td>Takes commands from the /intranet-notes/index page or the notes-list-compomponent and perform the selected action an all selected notes.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=824366&amp;path=packages/intranet-timesheet2-workflow/www/conf-objects/index.adp">index.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=824366&amp;path=packages/intranet-timesheet2-workflow/www/conf-objects/index.tcl">index.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=824366&amp;path=packages/intranet-timesheet2-workflow/www/conf-objects/new-timesheet-workflow.adp">new-timesheet-workflow.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=824366&amp;path=packages/intranet-timesheet2-workflow/www/conf-objects/new-timesheet-workflow.tcl">new-timesheet-workflow.tcl</a></b></td><td>Creates a new workflow for the associated hours</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=824366&amp;path=packages/intranet-timesheet2-workflow/www/conf-objects/new.adp">new.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=824366&amp;path=packages/intranet-timesheet2-workflow/www/conf-objects/new.tcl">new.tcl</a></b></td><td></td></tr><tr valign="top"><td><b>reports/</b></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=824366&amp;path=packages/intranet-timesheet2-workflow/www/reports/unsubmitted-hours.tcl">unsubmitted-hours.tcl</a></b></td><td>Report listing all main projects in the system with all available fields + DynFields from projects and customers</td></tr></table>

